var searchtype;
var myResults;
var collapsedState = 'YES';

// have to set this as widget.system only support files up to 4K

var outputFile = 'telefonkatalogen.txt';


function loaded() {

	stretcher = new Stretcher(document.getElementById('front'), 184, 370, changeText);
	calculateAndShowThumb(document.getElementById('results'));

	var updateButton = document.getElementById('checkUpdates');
	createGenericButton (updateButton, 'Oppdater widget', checkUpdates, 140);

	if(!widget.preferenceForKey('type')) {
		searchtype='company';
		widget.setPreferenceForKey('company', 'type');
		goCompany();
	}

	if(widget.preferenceForKey('type')=="person") {
		searchtype='person';
		goPerson();
	}
	
	if(widget.preferenceForKey('type')=="company") {
		searchtype='company';
		goCompany();
	}
}

if(window.widget) {
	widget.onremove = onremove;
}

function onremove() {
	if(myResults!=null) {
		myResults.cancel();
	}
}

function goPerson() {

	searchtype = 'person';
	
	bottomEdge.style.background = 'no-repeat url("Images/person_bottom.png")';
	front.style.background = 'no-repeat url("Images/person_top.png")';
	
	document.getElementById('results').innerHTML = '<br><br><center><b>Tips ved persons&oslash;k:</b><p>S&oslash;k etter person; <i>Ola Nordmann Oslo</i><br>S&oslash;k etter telefonummer (uten mellomrom): <i>22334455</i></p></center>';
    calculateAndShowThumb(document.getElementById('results'));
	
	document.searchForm.searchInput.focus();
	
	widget.setPreferenceForKey(searchtype, 'type');
	
	if(myResults!=null) {
		myResults.cancel();
	}
}

function goCompany() {

	searchtype = 'company';
	
	bottomEdge.style.background = 'no-repeat url("Images/company_bottom.png")';
	front.style.background = 'no-repeat url("Images/company_top.png")';
	
	document.getElementById('results').innerHTML = '<br><br><center><b>Tips ved firmas&oslash;k:</b><p>S&oslash;k etter firma og sted; <i>Apple Oslo</i><br>S&oslash;k etter telefonummer (uten mellomrom): <i>22334455</i></p></center>';
    calculateAndShowThumb(document.getElementById('results'));
	
	document.searchForm.searchInput.focus();
	
	widget.setPreferenceForKey(searchtype, 'type');
	
	if(myResults!=null) {
		myResults.cancel();
	}
}

function readInFile(filename) { 
    req = new XMLHttpRequest(); 
    req.open("GET", filename ,false); 
    req.send(null); 
    response = req.responseText; 
    if (response) { 
        return response; 
    } 
    return null 
}

function checkUpdates() {
	hidePrefs();
	checkVersion(event, 'person');
	checkVersion(event, 'company');
}

function checkVersion(event, parserFile) {

	if(myResults!=null) {
		myResults.cancel();
	}

	if(parserFile===null || parserFile==='') {
		var parserFile = searchtype;
	}

	var versionLocal = widget.system('/usr/bin/php -f Parsers/' + parserFile + '.php parserversion', null).outputString;
	var versionExternal = readInFile('http://www.vikingstad.com/widget/parsers/telefonkatalogen_' + parserFile + '.xml');	
	
	if(versionExternal>versionLocal || versionLocal===null || versionLocal.length>5 || event.shiftKey) {
		document.getElementById('results').innerHTML = '<br><br><center>Ny versjon har blitt funnet!<br>Vent til den er nedlastet...<br><br><img src="Images/waiting.gif"></center>';
		
		if( widget.system("/usr/bin/curl http://www.vikingstad.com/widget/parsers/telefonkatalogen_" + parserFile + " -o Parsers/" + parserFile + ".php", null).status===0) {
			document.getElementById('results').innerHTML = '<br><br><center>Nedlasting ferdig!<br>Du kan n&aring;  fortsette &aring; bruke widgeten!</center>';
			
		}
		else {
			document.getElementById('results').innerHTML = '<br><br><center>Et problem oppstod med nedlastingen av parserfilen.<br>Sjekk internettforbindelsen og pr&oslash;v igjen!<br>Hvis det gjentar seg, ta kontakt med utvikleren.</center>';
		}
				
	}
	else if (versionExternal===null) {
		document.getElementById('results').innerHTML = '<br><br><center>Det var et problem &aring; sjekket etter ny versjon.<br>Sjekk internettforbindelsen og pr&oslash;v igjen!<br>Hvis det gjentar seg, ta kontakt med utvikleren.';
	}
	else {
		document.getElementById('results').innerHTML = '<br><br><center>Du har siste versjon av parserfilen installert!</center>';
	}
}

function processRequest(search_term) {
	
	stretcher.open(event);
	
	if(myResults!=null) {
		myResults.cancel();
	}
	
	var searchPlus = encodeURI(search_term.replace(/[\s]/gi, '+'));
	
	document.getElementById('results').innerHTML = '<br><br><center>S&oslash;ker, vennligst vent...<br><br><img src="Images/waiting.gif"></center>';
	calculateAndShowThumb(document.getElementById('results'));

	var searchString = '/usr/bin/php -f Parsers/' + searchtype + '.php ' + searchPlus + ' > ' + outputFile;
	
	myResults = widget.system(searchString, endHandler);
	
}

function endHandler(result) {

	if(myResults.status===0) {
   		var theOutput = readInFile(outputFile);
   		document.getElementById('results').innerHTML = theOutput;
   		calculateAndShowThumb(document.getElementById('results'));

   		myResults.close();
	}
}


function showPrefs() {
	
	//huge hack here, can't figure out other way to do it!
	
	//stretcher.open(event);
    center.style.display="none";
    bottomEdge.style.display="none";
	topEdge.style.display="none";
	
	//front.style.display="none";
	
    var front = document.getElementById("front");
    var back = document.getElementById("back");
    var fliprollie = document.getElementById("fliprollie");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");

   // front.style.display="none";
    back.style.display="block";
    fliprollie.style.display="none";

   if (window.widget)
       setTimeout ('widget.performTransition();', 0);

}

function hidePrefs() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget)
        widget.prepareForTransition("ToFront");
    
    back.style.display="none";
    
    center.style.display="block";
    bottomEdge.style.display="block";
	topEdge.style.display="block";
    
    //front.style.display="block";
    
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);

}